# bigbob.inc
# model for the robot "Bigbob"
# Author: Jennifer Owen
# Date: 16/04/2010

#Bigbob's sonars
define bigbobs_sonars ranger
(
      # number of sonars
      scount 4

      # define the pose of each transducer [xpos ypos heading]      
      spose[0] [ 2  0     0]	  # right
      spose[1] [ 0    2  90]		# top
      spose[2] [ 0   -2 -90]		# bottom
      spose[3] [-2 -0   180]	  # left
		
      # define the field of view of each transducer 
      #[range_min range_max view_angle]
      sview [0 64 15]  # dat pozor na view_angle v pripade nepresnosti

      # define the size of each transducer
      # [xsize ysize] in meters
      ssize [0.01 0.05]
)

# bigbob's body
define bigbob position
(
      # actual size
      size [4 4 4]

      # Bigbob's centre of rotation is offset from its centre of area
      # origin [0.125 0 0 0]

      # the shape of Bigbob
 
	block
	(
		points 4
		point[3] [0 0]
		point[2] [0 4]
		point[1] [4 4]
		point[0] [4 0]
		z [0 4]
	)

  # differential steering model
  # later try to change to "omni"
# With omni drive enabled in Stage, you should be able to give x, y and
# a speeds independently. Try SetSpeed() with zeros for all but y and see if the robot
# moves sideways.

  drive "omni"
  localization "gps"
  localization_origin [0 0 0]

	# sensors attached to bigbob
  # 4 rangers
	bigbobs_sonars()  
	
	obstacle_return 1           	# can hit things
	ranger_return 1             	# reflects sonar beams
) 



