-- registr.vhd: registr
-- Author: Lucie Matusova, xmatus21, 3BIT

library IEEE;
use IEEE.std_logic_1164.all;

-- ----------------------------------------------------------------------------
--                        Entity declaration
-- ----------------------------------------------------------------------------

entity registr is
  generic ( 
    n : natural 
  );  
  port (
    CLK : in std_logic;
    RST : in std_logic;
    WR  : in std_logic;
    I   : in std_logic_vector (n-1 downto 0);
    O   : out std_logic_vector(n-1 downto 0) 
  );
end registr;      

-- ----------------------------------------------------------------------------
--                      Architecture declaration
-- ----------------------------------------------------------------------------

architecture behv of registr is
  signal R : std_logic_vector(n-1 downto 0);
begin

  process (CLK)
  begin
   
    if (CLK='1') and (CLK'event) then
      if (RST='1') then
        R <= (others => '0');
      elsif (WR='1') then
        R <= I;
      end if;
    end if;  

  end process;
  
  O <= R;

-- ---------------------------------------------------------------------------          
end behv;
